From fccf4e5b34453ed7421339b98d080154289c4a7b Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 05 2020 01:22:41 +0000
Subject: [PATCH 1659/2232] Fix Vec containing shared type from other module


---

diff --git a/syntax/check.rs b/syntax/check.rs
index 6dce563..21a8515 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -93,6 +93,7 @@ fn check_type_box(cx: &mut Check, ptr: &Ty1) {
 fn check_type_rust_vec(cx: &mut Check, ty: &Ty1) {
     if let Type::Ident(ident) = &ty.inner {
         if cx.types.cxx.contains(&ident.rust)
+            && !cx.types.aliases.contains_key(&ident.rust)
             && !cx.types.structs.contains_key(&ident.rust)
             && !cx.types.enums.contains_key(&ident.rust)
         {
@@ -328,6 +329,7 @@ fn check_api_type(cx: &mut Check, ety: &ExternType) {
             TrivialReason::StructField(strct) => format!("a field of `{}`", strct.name.rust),
             TrivialReason::FunctionArgument(efn) => format!("an argument of `{}`", efn.name.rust),
             TrivialReason::FunctionReturn(efn) => format!("a return value of `{}`", efn.name.rust),
+            TrivialReason::VecElement => format!("a vector element in Vec<{}>", ety.name.rust),
         };
         let msg = format!(
             "needs a cxx::ExternType impl in order to be used as {}",
diff --git a/syntax/types.rs b/syntax/types.rs
index 70b381f..e2f5bf8 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -201,6 +201,12 @@ impl<'a> Types<'a> {
                 _ => {}
             }
         }
+        for ty in &all {
+            if let Type::RustVec(ty) = ty {
+                let reason = TrivialReason::VecElement;
+                insist_alias_types_are_trivial(&ty.inner, reason);
+            }
+        }
 
         let mut types = Types {
             all,
@@ -297,6 +303,7 @@ pub enum TrivialReason<'a> {
     StructField(&'a Struct),
     FunctionArgument(&'a ExternFn),
     FunctionReturn(&'a ExternFn),
+    VecElement,
 }
 
 fn duplicate_name(cx: &mut Errors, sp: impl ToTokens, ident: &Ident) {

